/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// HandleValueDto
    /// </summary>
    [DataContract(Name = "HandleValueDto")]
    public partial class HandleValueDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HandleValueDto" /> class.
        /// </summary>
        /// <param name="idx">idx.</param>
        /// <param name="type">type.</param>
        /// <param name="parsedData">parsedData.</param>
        /// <param name="data">data.</param>
        /// <param name="timestamp">timestamp.</param>
        /// <param name="ttlType">ttlType.</param>
        /// <param name="ttl">ttl.</param>
        /// <param name="refs">refs.</param>
        /// <param name="privs">privs.</param>
        public HandleValueDto(int idx = default(int), string type = default(string), Object parsedData = default(Object), string data = default(string), DateTime timestamp = default(DateTime), int ttlType = default(int), int ttl = default(int), List<Object> refs = default(List<Object>), string privs = default(string))
        {
            this.Idx = idx;
            this.Type = type;
            this.ParsedData = parsedData;
            this.Data = data;
            this.Timestamp = timestamp;
            this.TtlType = ttlType;
            this.Ttl = ttl;
            this.Refs = refs;
            this.Privs = privs;
        }

        /// <summary>
        /// Gets or Sets Idx
        /// </summary>
        [DataMember(Name = "idx", EmitDefaultValue = false)]
        public int Idx { get; set; }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public string Type { get; set; }

        /// <summary>
        /// Gets or Sets ParsedData
        /// </summary>
        [DataMember(Name = "parsed_data", EmitDefaultValue = true)]
        public Object ParsedData { get; set; }

        /// <summary>
        /// Gets or Sets Data
        /// </summary>
        [DataMember(Name = "data", EmitDefaultValue = false)]
        public string Data { get; set; }

        /// <summary>
        /// Gets or Sets Timestamp
        /// </summary>
        [DataMember(Name = "timestamp", EmitDefaultValue = false)]
        public DateTime Timestamp { get; set; }

        /// <summary>
        /// Gets or Sets TtlType
        /// </summary>
        [DataMember(Name = "ttl_type", EmitDefaultValue = false)]
        public int TtlType { get; set; }

        /// <summary>
        /// Gets or Sets Ttl
        /// </summary>
        [DataMember(Name = "ttl", EmitDefaultValue = false)]
        public int Ttl { get; set; }

        /// <summary>
        /// Gets or Sets Refs
        /// </summary>
        [DataMember(Name = "refs", EmitDefaultValue = false)]
        public List<Object> Refs { get; set; }

        /// <summary>
        /// Gets or Sets Privs
        /// </summary>
        [DataMember(Name = "privs", EmitDefaultValue = false)]
        public string Privs { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class HandleValueDto {\n");
            sb.Append("  Idx: ").Append(Idx).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ParsedData: ").Append(ParsedData).Append("\n");
            sb.Append("  Data: ").Append(Data).Append("\n");
            sb.Append("  Timestamp: ").Append(Timestamp).Append("\n");
            sb.Append("  TtlType: ").Append(TtlType).Append("\n");
            sb.Append("  Ttl: ").Append(Ttl).Append("\n");
            sb.Append("  Refs: ").Append(Refs).Append("\n");
            sb.Append("  Privs: ").Append(Privs).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
